/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.generictype;

import java.lang.reflect.Constructor;
import java.lang.reflect.GenericDeclaration;
import java.lang.reflect.Method;
import java.util.List;

/**
 * {@link GenericDeclaration}Ӧͱࣺ
 * <ul>
 * <li>{@link ClassTypeInfo}{@link Class}</li>
 * <li>{@link MethodInfo}{@link Method}{@link Constructor}</li>
 * </ul>
 * 
 * @author Michael Zhou
 */
public interface GenericDeclarationInfo {
    /**
     * жϵǰǷΪgeneric༴Ƿͱ磺<code>List&lt;E&gt;</code>
     */
    boolean isGeneric();

    /**
     * ȡͲ
     * <p>
     * 磬<code>Map&lt;K, V&gt;</code>ĲΪ<code>[K, V]</code><br>
     * genericͣ򷵻ؿб
     * </p>
     */
    List<TypeVariableInfo> getTypeParameters();

    /**
     * ȡͲӦʵ͡
     * <p>
     * 磬{@link RawTypeInfo}<code>MyClass&lt;A extends Number, B&gt;</code>
     * ӦʵʲΪ <code>[Number, Object]</code><br>
     * {@link ParameterizedTypeInfo}<code>List&lt;E=Integer&gt;</code>
     * ӦʵʲΪ<code>[Integer]</code>
     * </p>
     * <p>
     * genericͣ򷵻ؿб
     * </p>
     */
    List<TypeInfo> getActualTypeArguments();

    /**
     * ȡָƵʵ͡
     * <p>
     * 磬{@link RawTypeInfo}<code>MyClass&lt;A extends Number, B&gt;</code>
     * <code>A</code>ӦʵʲΪ <code>Number</code><br>
     * {@link ParameterizedTypeInfo}<code>List&lt;E=Integer&gt;</code> 
     * <code>E</code>ӦʵʲΪ<code>Integer</code>
     * </p>
     * <p>
     * ڣ򷵻<code>null</code>
     * </p>
     */
    TypeInfo getActualTypeArgument(String name);
}
