/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.generictype;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.List;

import com.alibaba.citrus.codegen.util.MethodSignature;

/**
 * һ{@link Method}{@link Constructor}Ϣ
 * 
 * @author Michael Zhou
 */
public interface MethodInfo extends GenericDeclarationInfo {
    /**
     * ǷΪ캯
     */
    boolean isConstructor();

    /**
     * ȡ÷Ƿ򷵻<code>null</code>
     */
    Method getMethod();

    /**
     * ȡù캯ǹ캯򷵻<code>null</code>
     */
    Constructor<?> getConstructor();

    /**
     * ȡõǰڵ͡
     */
    TypeInfo getDeclaringType();

    /**
     * ȡõǰ캯ǩ
     * <p>
     * ǩֻƺͲϢ
     * </p>
     */
    MethodSignature getSignature();

    /**
     * ȡ÷캯ķη
     */
    int getModifiers();

    /**
     * ȡ÷͡
     */
    TypeInfo getReturnType();

    /**
     * ȡ÷ƣڹ캯򷵻<code>&lt;init&gt;</code>
     */
    String getName();

    /**
     * ȡòͱ
     */
    List<TypeInfo> getParameterTypes();

    /**
     * ȡ쳣ͱ
     */
    List<TypeInfo> getExceptionTypes();

    /**
     * ȡЧ쳣ͱǴ<code>RuntimeException</code><code>Error</code>쳣<br>
     * ޳ص쳣<code>Exception</code><code>IOException</code>ͬʱ֣ɾ
     * <code>IOException</code>
     */
    List<TypeInfo> getEffectiveExceptionTypes();

    /**
     * ָзķֵ͡쳣͵ʵ͡
     * <p>
     * ൱{@link resolve(context, true)}
     * </p>
     */
    MethodInfo resolve(GenericDeclarationInfo context);

    /**
     * ָзķֵ͡쳣͵ʵ͡
     * <p>
     * <code>includeBaseType==false</code>ôͱʱȡbaseType 
     * </p>
     * <p>
     * μ{@link TypeInfo.resolve()}
     * </p>
     */
    MethodInfo resolve(GenericDeclarationInfo context, boolean includeBaseType);
}
