/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.form;

import javax.servlet.http.HttpServletRequest;

import com.alibaba.citrus.service.form.configuration.FieldConfig;
import com.alibaba.citrus.service.requestcontext.util.ValueList;

/**
 * ûύеһfield
 * <p>
 * ע⣺field̰߳ȫģܱ̹߳
 * </p>
 * 
 * @author Michael Zhou
 */
public interface Field extends ValueList, CustomErrors {
    /**
     * ȡfieldϢ
     */
    FieldConfig getFieldConfig();

    /**
     * ȡðfieldgroup
     */
    Group getGroup();

    /**
     * жfieldǷ֤ͨ
     */
    boolean isValid();

    /**
     * ȡformΨһfieldkey
     * <p>
     * ɹ̶ǰ׺<code>"_fm"</code>groupдgroup instance
     * fieldKeyټfieldдɡ磺<code>_fm.m._0.n</code>
     * </p>
     */
    String getKey();

    /**
     * ȡformΨһfieldkeyûύıδfieldϢʱȡkeyֵΪfieldֵ
     * <p>
     * checkbox֮HTMLؼرá
     * </p>
     * <p>
     * KeyĸʽΪ<code>_fm.groupKey.instanceKey.fieldKey.absent</code>
     * </p>
     */
    String getAbsentKey();

    /**
     * ȡformк͵ǰfield󶨵ĸkey
     * <p>
     * KeyĸʽΪ<code>_fm.groupKey.instanceKey.fieldKey.attach</code>
     * </p>
     */
    String getAttachmentKey();

    /**
     * ȡóϢ
     */
    String getMessage();

    /**
     * ʼfieldֵֶ֤ΡУ<code>request</code><code>null</code>
     */
    void init(HttpServletRequest request);

    /**
     * ȡfield name൱<code>getFieldConfig().getName()</code>
     */
    String getName();

    /**
     * ȡòֵָƵĲڣ򷵻<code>""</code>
     */
    String getStringValue();

    /**
     * ȡʾfieldƣ൱<code>getFieldConfig().getDisplayName()</code>
     */
    String getDisplayName();

    /**
     * ȡĬֵ൱<code>getFieldConfig().getDefaultValue()</code>
     */
    String getDefaultValue();

    /**
     * ȡĬֵ൱<code>getFieldConfig().getDefaultValues()</code>
     */
    String[] getDefaultValues();

    /**
     * Ӳ/ֵ
     */
    void addValue(Object value);

    /**
     * ø
     */
    Object getAttachment();

    /**
     * ñĸ
     */
    String getAttachmentEncoded();

    /**
     * Ƿ
     */
    boolean hasAttachment();

    /**
     * ø
     * <p>
     * ע⣬attachmentѾʱ÷Чǿ룬ȵ<code>clearAttachment()</code>
     * </p>
     */
    void setAttachment(Object attachment);

    /**
     * 
     */
    void clearAttachment();
}
