/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.form;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;

import com.alibaba.citrus.service.form.configuration.GroupConfig;

/**
 * ûύеһֶΡ
 * <p>
 * ע⣺group̰߳ȫģܱ̹߳
 * </p>
 * 
 * @author Michael Zhou
 */
public interface Group {
    /**
     * ȡgroupϢ
     */
    GroupConfig getGroupConfig();

    /**
     * ȡðgroupform
     */
    Form getForm();

    /**
     * ȡgroup name൱<code>getGroupConfig().getName()</code>
     */
    String getName();

    /**
     * ȡôgroupkey
     * <p>
     * ɹ̶ǰ׺<code>"_fm"</code>groupдټgroup instance keyɡ磺
     * <code>_fm.m._0</code>
     * </p>
     */
    String getKey();

    /**
     * ȡñʶǰgroupinstance key
     */
    String getInstanceKey();

    /**
     * жgroupǷ֤ͨ
     */
    boolean isValid();

    /**
     * жgroupǷֵ֤£<code>isValidated()</code>Ϊ<code>true</code>
     * <ol>
     * <li>ûύǰgroupֶεıʱӦgroupʼ֤</li>
     * <li><code>validate()</code>ַʽ£groupеֵֶɳãЧͬûύһ</li>
     * </ol>
     */
    boolean isValidated();

    /**
     * ʼgroup
     */
    void init();

    /**
     * ʼgroup У <code>request</code><code>null</code>
     * <code>request</code>Ϊ<code>null</code>ͬʱ֤
     */
    void init(HttpServletRequest request);

    /**
     * ֤֤ǰֵֶ
     * <p>
     * ע⣬˷<code>isValidated()</code>Ϊ<code>true</code>
     * </p>
     */
    void validate();

    /**
     * ȡfieldsб
     */
    Collection<Field> getFields();

    /**
     * ȡָƵfieldfieldƣСдУ
     */
    Field getField(String fieldName);

    /**
     * еֵ뵽fieldsС
     * <p>
     * <code>isValidated()</code>Ϊ<code>true</code>group÷Ч
     * </p>
     */
    void mapTo(Object object);

    /**
     * groupеֵָ
     * <p>
     * <code>isValidated()</code>Ϊ<code>false</code>group÷Ч
     * </p>
     */
    void setProperties(Object object);
}
