/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.form.configuration;

import java.util.List;

import org.springframework.beans.PropertyEditorRegistrar;

import com.alibaba.citrus.service.form.FormService;

/**
 * һformĶϢ
 * <p>
 * Formǲɸĵġ
 * </p>
 * 
 * @author Michael Zhou
 */
public interface FormConfig {
    /**
     * ȡôformservice
     */
    FormService getFormService();

    /**
     * תʱǷ񲻱ǷĬֵ
     */
    boolean isConverterQuiet();

    /**
     * GroupǷĬϱpostȡݡ
     */
    boolean isPostOnlyByDefault();

    /**
     * ȡmessage codeǰ׺
     * <p>
     * ValidatorԴspring <code>MessageSource</code>
     * ȡmessageݡmessagecodeΪ
     * <code>messageCodePrefix.groupName.fieldName.validatorId</code>
     * </p>
     * <p>
     * Ĭϵǰ׺Ϊ<code>form.</code>
     * </p>
     */
    String getMessageCodePrefix();

    /**
     * ȡgroup configб
     */
    List<GroupConfig> getGroupConfigList();

    /**
     * ȡָƵgroup configƴСдС δҵ򷵻<code>null</code>
     */
    GroupConfig getGroupConfig(String groupName);

    /**
     * ȡúָkeyӦgroup configδҵ򷵻<code>null</code>
     */
    GroupConfig getGroupConfigByKey(String groupKey);

    /**
     * ȡ<code>PropertyEditor</code>ע
     * <p>
     * <code>PropertyEditor</code>ֵַתbean property֮ͣ
     * </p>
     */
    PropertyEditorRegistrar getPropertyEditorRegistrar();
}
