/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.pull;

/**
 * һpull toolsĹ
 * <p>
 * singletonȷܡǺ<code>ToolSetFactory</code>ͬǣ
 * <code>RuntimeToolSetFactory.getToolNames()</code>
 * ϵͳʼʱõģÿ౻һΡ
 * </p>
 * <p>
 * ͵Ķܲ<code>ToolSetFactory</code>뾡ʹúߡ
 * </p>
 * 
 * @see ToolFactory
 * @see ToolSetFactory
 * @author Michael Zhou
 */
public interface RuntimeToolSetFactory {
    /**
     * ȡtoolsetʵ
     * <p>
     * ÷ÿʱ౻һΡ
     * </p>
     * <p>
     * 緵<code>null</code>ʾtoolá
     * </p>
     * <p>
     * ע⣺ÿε<strong></strong>زͬĶ
     * </p>
     */
    Object createToolSet() throws Exception;

    /**
     * ȡtoolsơ
     * <p>
     * ÿУ÷ᱻһΡ
     * </p>
     */
    Iterable<String> getToolNames(Object toolSet);

    /**
     * ȡָƵtoolʵ
     * <p>
     * ڷsingletonͣ÷ÿʱÿ<code>name</code>౻һΡ
     * </p>
     * <p>
     * 緵<code>null</code>ʾtoolá
     * </p>
     */
    Object createTool(Object toolSet, String name) throws Exception;
}
