/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.pull;

/**
 * һpull toolsĹ
 * <p>
 * singletonȷܡ
 * </p>
 * <ul>
 * <li><code>getToolNames()</code>ϵͳʼʱãPre-queueing</li>
 * <li><code>isSingleton() == true</code> ʱ<code>createTool(name)</code>
 * ϵͳʼʱãPre-pulling</li>
 * <li><code>isSingleton() == false</code> ʱÿһ󣬶ÿ<code>name</code>
 * <code>createTool(name)</code> ౻һΡ</li>
 * </ul>
 * 
 * @see ToolFactory
 * @author Michael Zhou
 */
public interface ToolSetFactory {
    /**
     * Factorytoolǲsingleton
     */
    boolean isSingleton();

    /**
     * ȡtoolsơ
     * <p>
     * ϵͳʼʱ÷ᱻһΣԺٵá
     * </p>
     */
    Iterable<String> getToolNames();

    /**
     * ȡָƵtoolʵ
     * <p>
     * ڷsingletonͣ÷ÿʱÿ<code>name</code>౻һΡ
     * </p>
     * <p>
     * 緵<code>null</code>ʾtoolá
     * </p>
     * <p>
     * ע⣺ڷsingletonͣ<strong></strong>ÿηزͬĶ
     * </p>
     */
    Object createTool(String name) throws Exception;
}
