/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.requestcontext.lazycommit;

import com.alibaba.citrus.service.requestcontext.RequestContext;

/**
 * ӳύresponseЩĵûᵼresponseύ
 * <ul>
 * <li><code>sendError</code></li>
 * <li><code>sendRedirect</code></li>
 * <li><code>flushBuffer</code></li>
 * <li><code>setContentLength()</code>
 * <code>setHeader("Content-Length", len)</code>Щservlet
 * engineύresponse</li>
 * </ul>
 * ResponseһύͲ޸headerˡһЩӦãcookie-based sessionʵһ⡣
 * <p>
 * ʹӳύ֧ЩӦá
 * </p>
 * <p>
 * ע⣬ಢδ<code>getWriter()</code><code>getOutputStream()</code>
 * ύЩύҪ<code>BufferedRequestContext</code>
 * </p>
 * 
 * @author Michael Zhou
 */
public interface LazyCommitRequestContext extends RequestContext {
    /**
     * жϵǰǷѳ
     * 
     * @return 򷵻<code>true</code>
     */
    boolean isError();

    /**
     * <code>sendError()</code>ã÷һerror״ֵ̬
     * 
     * @return error״ֵ̬ϵͳ򷵻<code>0</code>
     */
    int getErrorStatus();

    /**
     * <code>sendError()</code>ã÷һerrorϢ
     * 
     * @return errorϢϵͳ򷵻<code>null</code>
     */
    String getErrorMessage();

    /**
     * жϵǰǷѱض
     * 
     * @return ض򷵻<code>true</code>
     */
    boolean isRedirected();

    /**
     * ȡضURI
     * 
     * @return ضURIûض򷵻<code>null</code>
     */
    String getRedirectLocation();

    /**
     * ȡõHTTP status
     * 
     * @return HTTP statusֵ
     */
    int getStatus();
}
