/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.requestcontext.parser;

import org.apache.commons.fileupload.FileItem;

import com.alibaba.citrus.service.upload.UploadException;
import com.alibaba.citrus.service.upload.UploadParameters;

/**
 * <code>ParameterParser</code>HTTPGETPOSTĲĽӿڡ
 * 
 * @author Michael Zhou
 */
public interface ParameterParser extends ValueParser {
    /**
     * ȡָƵ<code>FileItem</code>ڣ򷵻<code>null</code>
     * 
     * @param key 
     * @return <code>FileItem</code>
     */
    FileItem getFileItem(String key);

    /**
     * ȡָƵ<code>FileItem</code>ڣ򷵻<code>null</code>
     * 
     * @param key 
     * @return <code>FileItem</code>
     */
    FileItem[] getFileItems(String key);

    /**
     * <code>FileItem</code>
     * 
     * @param name 
     * @param value ֵ
     */
    void add(String name, FileItem value);

    /**
     * <a href="http://www.ietf.org/rfc/rfc1867.txt">RFC 1867</a>׼
     * <code>multipart/form-data</code>͵HTTP
     * <p>
     * Ҫִд˷뽫<code>UploadService.automatic</code>òó<code>false</code>
     * ˷serviceĬãʺactionservletִֹС
     * </p>
     * 
     * @throws UploadException ʱ
     */
    void parseUpload() throws UploadException;

    /**
     * <a href="http://www.ietf.org/rfc/rfc1867.txt">RFC 1867</a>׼
     * <code>multipart/form-data</code>͵HTTP
     * <p>
     * Ҫִд˷뽫<code>UploadService.automatic</code>òó<code>false</code>
     * ˷serviceĬãʺactionservletִֹС
     * </p>
     * 
     * @param sizeThreshold ļڴеֵСڴֵļڴСֵС0ʹԤֵ
     * @param sizeMax HTTPߴ磬˳ߴ󽫱
     * @param repositoryPath ݴļľ·
     * @throws UploadException ʱ
     */
    void parseUpload(UploadParameters params) throws UploadException;

    /**
     * parametersװquery string
     * 
     * @return query stringûв򷵻<code>null</code>
     */
    String toQueryString();
}
