/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.requestcontext.parser;

import org.springframework.beans.PropertyEditorRegistrar;

import com.alibaba.citrus.service.requestcontext.RequestContext;

/**
 * Զrequest parameterscookie parameters͸شuploadrequest contextʵ֡
 * 
 * @author Michael Zhou
 */
public interface ParserRequestContext extends RequestContext {
    /** ļԿѡparameterscookiesƽдСдת */
    String URL_CASE_FOLDING_NONE = "none";

    /** ļԿѡparameterscookiesתСд */
    String URL_CASE_FOLDING_LOWER = "lower";

    /** ļԿѡparameterscookiesתСд»ߡ */
    String URL_CASE_FOLDING_LOWER_WITH_UNDERSCORES = "lower_with_underscores";

    /** ļԿѡparameterscookiesתɴд */
    String URL_CASE_FOLDING_UPPER = "upper";

    /** ļԿѡparameterscookiesתɴд»ߡ */
    String URL_CASE_FOLDING_UPPER_WITH_UNDERSCORES = "upper_with_underscores";

    /** Ĭϵıַ */
    String DEFAULT_CHARSET_ENCODING = "ISO-8859-1";

    /** parametersбʾuploadʧܣ󱻺ԡ */
    String UPLOAD_FAILED = "upload_failed";

    /** parametersбʾuploadļߴ糬ֵ󱻺ԡ */
    String UPLOAD_SIZE_LIMIT_EXCEEDED = "upload_size_limit_exceeded";

    /**
     * ȡת͵propertyEditorע
     */
    PropertyEditorRegistrar getPropertyEditorRegistrar();

    /**
     * תʱǷ񲻱ǷĬֵ
     */
    boolean isConverterQuiet();

    /**
     * ǷԶִUpload
     */
    boolean isAutoUpload();

    /**
     * ȡôHTMLֶεĺ׺
     */
    String getHtmlFieldSuffix();

    /**
     * ָķתparameterscookiesƣĬΪСд»ߡ
     */
    String getCaseFolding();

    /**
     * ǷԲHTML entities룬ĬΪ<code>true</code>
     */
    boolean isUnescapeParameters();

    /**
     * ǷʹservletparserĬΪ<code>false</code>
     */
    boolean isUseServletEngineParser();

    /**
     * Ƿrequest.setCharacterEncodingָıqueryĬΪ<code>true</code>
     * <p>
     * ֻе<code>useServletEngineParser==false</code>ʱѡЧ
     * </p>
     */
    boolean isUseBodyEncodingForURI();

    /**
     * <code>useServletEngineParser==false</code>
     * <code>useBodyEncodingForURI=false</code>ʱøñGETĲ
     */
    String getURIEncoding();

    /**
     * ǷtrimmingĬΪ<code>true</code>
     */
    boolean isTrimming();

    /**
     * ȡqueryһִд˷ʱrequestȡеĲ
     * 
     * @return <code>ParameterParser</code>ʵ
     */
    ParameterParser getParameters();

    /**
     * ȡcookieһִд˷ʱrequestȡcookies
     * 
     * @return <code>CookieParser</code>ʵ
     */
    CookieParser getCookies();

    /**
     * ַָ<code>getCaseFolding()</code>ãתָСдʽ
     * 
     * @param str Ҫתַ
     * @return תַ
     */
    String convertCase(String str);
}
