/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.requestcontext.util;

import java.io.UnsupportedEncodingException;
import java.text.DateFormat;
import java.util.Date;

import org.apache.commons.fileupload.FileItem;
import org.springframework.core.MethodParameter;

/**
 * һֵб
 * 
 * @author Michael Zhou
 */
public interface ValueList {
    // =============================================================
    //  ȡòֵ 
    // =============================================================

    /**
     * ȡòֵָƵĲڣ򷵻<code>false</code>
     * 
     * @return ֵ
     */
    boolean getBooleanValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    boolean getBooleanValue(Boolean defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    byte getByteValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    byte getByteValue(Byte defaultValue);

    /**
     * ȡָֽڡ
     * 
     * @param charset תַı
     * @return ֵֽ
     * @throws UnsupportedEncodingException ָ˴ıַ
     */
    byte[] getBytes(String charset) throws UnsupportedEncodingException;

    /**
     * ȡòֵָƵĲڣ򷵻<code>'\0'</code>
     * 
     * @return ֵ
     */
    char getCharacterValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    char getCharacterValue(Character defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    double getDoubleValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    double getDoubleValue(Double defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    float getFloatValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    float getFloatValue(Float defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    int getIntegerValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    int getIntegerValue(Integer defaultValue);

    /**
     * ȡֵָڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    int[] getIntegerValues();

    /**
     * ȡֵָڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    int[] getIntegerValues(int[] defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    long getLongValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    long getLongValue(Long defaultValue);

    /**
     * ȡֵָڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    long[] getLongValues();

    /**
     * ȡֵָڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    long[] getLongValues(long[] defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>0</code>
     * 
     * @return ֵ
     */
    short getShortValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    short getShortValue(Short defaultValue);

    /**
     * ȡڡַʹָ<code>DateFormat</code>ڣ򷵻<code>null</code>
     * 
     * @param format <code>DateFormat</code>
     * @return <code>java.util.Date</code>
     */
    Date getDateValue(DateFormat format);

    /**
     * ȡڡַʹָ<code>DateFormat</code>ڣ򷵻Ĭֵ
     * 
     * @param format <code>DateFormat</code>
     * @param defaultValue Ĭֵ
     * @return <code>java.util.Date</code>
     */
    Date getDateValue(DateFormat format, Date defaultValue);

    /**
     * ȡòֵָƵĲڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    String getStringValue();

    /**
     * ȡòֵָƵĲڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    String getStringValue(String defaultValue);

    /**
     * ȡֵָڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    String[] getStringValues();

    /**
     * ȡֵָڣ򷵻ָĬֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    String[] getStringValues(String[] defaultValue);

    /**
     * ȡ<code>FileItem</code>ڣ򷵻<code>null</code>
     * 
     * @return <code>FileItem</code>
     */
    FileItem getFileItem();

    /**
     * ȡ<code>FileItem</code>ڣ򷵻<code>null</code>
     * 
     * @return <code>FileItem</code>
     */
    FileItem[] getFileItems();

    /**
     * ȡֵָڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    Object getValue();

    /**
     * ȡֵָڣ򷵻Ĭֵ
     * 
     * @param defaultValue Ĭֵ
     * @return ֵ
     */
    Object getValue(Object defaultValue);

    /**
     * ȡֵָڣ򷵻<code>null</code>
     * 
     * @return ֵ
     */
    Object[] getValues();

    /**
     * ȡֵָڣ򷵻ָĬֵ
     * 
     * @param defaultValues Ĭֵ
     * @return ֵ
     */
    Object[] getValues(Object[] defaultValues);

    /**
     * ȡָ͵ֵ
     */
    <T> T getValueOfType(Class<T> type, MethodParameter methodParameter, Object[] defaultValues);

    /**
     * ȡָ͵ֵ
     */
    <T> T getValueOfType(Class<T> type, boolean isPrimitive, MethodParameter methodParameter, Object[] defaultValues);

    // =============================================================
    //  Ӻ޸Ĳķ
    // =============================================================

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(boolean value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(byte value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(char value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(double value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(float value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(int value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(long value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(short value);

    /**
     * Ӳ/ֵ
     * 
     * @param value ֵ
     */
    void addValue(Object value);

    /**
     * òֵ<code>add</code>ͬ˷ԭеֵ
     * 
     * @param value ֵ
     */
    void setValue(Object value);

    /**
     * òֵ<code>add</code>ͬ˷ԭеֵ
     * 
     * @param values ֵ
     */
    void setValues(Object[] values);

    // =============================================================
    //  
    // =============================================================

    /**
     * ȡֵĸ
     * 
     * @return ֵĸ
     */
    int size();
}
