/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.resource;

import static java.util.Collections.*;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.EnumSet;
import java.util.Set;

/**
 * װԴserviceȡָƵԴURLļFileInputStream
 * <p>
 * Ҫעǣ͵ԴͬʱȡURLFileInputStreamġ
 * </p>
 * 
 * @author Michael Zhou
 */
public interface ResourceLoadingService {
    /**
     * ѡ<code>FOR_CREATE</code>
     */
    Set<ResourceLoadingOption> FOR_CREATE = unmodifiableSet(EnumSet.of(ResourceLoadingOption.FOR_CREATE));

    /**
     * ȡparentװط
     */
    ResourceLoadingService getParent();

    /**
     * ָƵԴ
     */
    URL getResourceAsURL(String resourceName) throws ResourceNotFoundException;

    /**
     * ָƵԴ
     */
    File getResourceAsFile(String resourceName) throws ResourceNotFoundException;

    /**
     * ָƵԴ
     */
    File getResourceAsFile(String resourceName, Set<ResourceLoadingOption> options) throws ResourceNotFoundException;

    /**
     * ָƵԴ
     */
    InputStream getResourceAsStream(String resourceName) throws ResourceNotFoundException, IOException;

    /**
     * ָƵԴ
     */
    Resource getResource(String resourceName) throws ResourceNotFoundException;

    /**
     * ָƵԴ
     */
    Resource getResource(String resourceName, Set<ResourceLoadingOption> options) throws ResourceNotFoundException;

    /**
     * жָƵԴǷڡڣ򷵻<code>true</code>
     */
    boolean exists(String resourceName);

    /**
     * ٲȡԴ·
     * <p>
     * ʹԴ޷ҵ<code>trace</code>Ҳ᷵Թ·׳쳣
     * </p>
     * <p>
     * ÷ҪڵԺͲԷ
     * </p>
     */
    ResourceTrace trace(String resourceName);

    /**
     * ٲȡԴ·
     * <p>
     * ʹԴ޷ҵ<code>trace</code>Ҳ᷵Թ·׳쳣
     * </p>
     * <p>
     * ÷ҪڵԺͲԷ
     * </p>
     */
    ResourceTrace trace(String resourceName, Set<ResourceLoadingOption> options);

    /**
     * гָԴĿ¼ļĿ¼<code>/</code>βĿ¼ڣ򷵻<code>null</code>
     */
    String[] list(String resourceName) throws ResourceNotFoundException;

    /**
     * гָԴĿ¼ļĿ¼<code>/</code>βĿ¼ڣ򷵻<code>null</code>
     */
    String[] list(String resourceName, Set<ResourceLoadingOption> options) throws ResourceNotFoundException;

    /**
     * гָԴĿ¼ļԴĿ¼ڣ򷵻<code>null</code>
     */
    Resource[] listResources(String resourceName) throws ResourceNotFoundException;

    /**
     * гָԴĿ¼ļԴĿ¼ڣ򷵻<code>null</code>
     */
    Resource[] listResources(String resourceName, Set<ResourceLoadingOption> options) throws ResourceNotFoundException;

    /**
     * ȡеpatternsơ
     */
    String[] getPatterns(boolean includeParent);
}
