/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.service.upload;

import java.io.File;

import com.alibaba.citrus.util.HumanReadableSize;

/**
 * <code>UploadService</code>Ĳ
 * 
 * @author Michael Zhou
 */
public interface UploadConfiguration {
    /** ĬֵHTTPߴ磬˳ߴ󽫱 */
    long SIZE_MAX_DEFAULT = -1;

    /** Ĭֵļߴ磬˳ߴ󽫱 */
    long FILE_SIZE_MAX_DEFAULT = -1;

    /** ĬֵļڴеֵСڴֵļڴС */
    int SIZE_THRESHOLD_DEFAULT = 10240;

    /**
     * ȡݴļĿ¼
     */
    File getRepository();

    /**
     * ȡHTTPߴ磬˳ߴ󽫱λֽڣֵ<code>-1</code>ʾûơ
     */
    HumanReadableSize getSizeMax();

    /**
     * ȡõļߴ磬˳ߴļλֽڣֵ<code>-1</code>ʾûơ
     */
    HumanReadableSize getFileSizeMax();

    /**
     * ȡýļڴеֵСڴֵļڴСλֽڡ
     */
    HumanReadableSize getSizeThreshold();

    /**
     * Ƿͨform fieldڴ<code>sizeThreshold</code>ֵΪ<code>0</code>
     * ʱ򣬸ֵԶΪ<code>true</code>
     */
    boolean isKeepFormFieldInMemory();

    /**
     * ׼ϴļУݣ
     * <code>Content-Disposition: attachment; filename=xxx.txt</code>
     * ȻЩ淶Ӧãȡ<code>fname=xxx.txt</code>˱Ϊ衣
     */
    String[] getFileNameKey();
}
