/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.util;

import java.io.Serializable;

/**
 * ҳ
 * <p>
 * webҳϷҳʾݣҳ͵ǰҳƫʮַʵá
 * </p>
 * <p>
 * ֻҪ֪ܹжǰʾÿҳÿҳʾͿ԰ݣұ֤м㶼óֵõҳ볬߽֮⡣
 * </p>
 * <p>
 * ʹ÷:
 * 
 * <pre>
 * <![CDATA[
 * 
 *   // һҳڴָÿҳʾҲԺָ
 *   // ûָʹĬֵÿҳʾ10
 *   Paginator pg = new Paginator();        //  new Paginator(itemsPerPage);
 * 
 *   // ܹмС0Ϳ0
 *   pg.setItems(123);
 * 
 *   // ֪м
 *   pg.setItems(Paginator.UNKNOWN_ITEMS);
 * 
 *   // ĬϵǰҳǵһҳԸı
 *   pg.setPage(3);                         // ǰҳ3ˣõҳᳬҳ
 * 
 *   // Եõˡ
 *   int currentPage = pg.getPage();        // õǰҳ
 *   int totalPages  = pg.getPages();       // ܹмҳ
 *   int totalItems  = pg.getItems();       // ܹм
 *   int beginIndex  = pg.getBeginIndex();  // õǰҳһ(1ʼ)
 *   int endIndex    = pg.getEndIndex();    // õǰҳһ(ҲǴ1ʼ)
 *   int offset      = pg.getOffset();      // offsetlengthΪmysqlѯ
 *   int length      = pg.getLength();      //     limit offsetlengthӾ䡣
 * 
 *   // 
 *   setItemsPerPage(20);                   // ÿҳʾ20ˣǰҳֵԶ,
 *                                          //     ʹҳԭҳʾͬûԻ
 *   setItem(33);                           // ԰ҳʾ33(0ʼ)һҳ
 * 
 *   // ߼ܣһڡǾҪwebҳʾһҳ룬ûѡ
 *   //        ____________________________________________________________
 *   // :  <<     <       3     4    5    6    [7]    8    9    >    >>
 *   //        ^      ^                             ^               ^    ^
 *   //       һҳ ǰһҳ                       ǰҳ          һҳ һҳ
 *   //
 *   // ӾһСΪ7Ļڣǰҳ뱻ܰм䣬ǵǰҳλڿͷβ
 *   // ʹĵãͿԵõָСĻеҳ顣
 *   int[] slider = pg.getSlider(7);
 * 
 *   // жָҳǷЧǵǰҳЧҳwebҳϲҪӡ
 *   if (pg.isDisabledPage(slider[i])) {
 *       show = "page " + slider[i];
 *   } else {
 *       show = "<a href=#> page " + slider[i] + " </a>";
 *   }
 * 
 *   // ֱӴӡpgڵԳ
 *   System.out.println(pg);
 *   log.debug(pg);
 * 
 * ]]>
 * </pre>
 * 
 * </p>
 */
public class Paginator implements Serializable, Cloneable {
    private static final long serialVersionUID = 3688506614705500726L;

    /** ÿҳĬϵ(10) */
    public static final int DEFAULT_ITEMS_PER_PAGE = 10;

    /** ĬϵĴС(7) */
    public static final int DEFAULT_SLIDER_SIZE = 7;

    /** ʾδ֪(<code>Integer.MAX_VALUE</code>) */
    public static final int UNKNOWN_ITEMS = Integer.MAX_VALUE;

    // ״̬
    private int page; // ǰҳ롣(1-based)
    private int items; // ܹ
    private int itemsPerPage; // ÿҳ

    /**
     * һҳʼΪ޴<code>UNKNOWN_ITEMS</code>Ĭÿҳʾ<code>10</code>
     */
    public Paginator() {
        this(0);
    }

    /**
     * һҳʼΪ޴<code>UNKNOWN_ITEMS</code>ָÿҳ
     * 
     * @param itemsPerPage ÿҳ
     */
    public Paginator(int itemsPerPage) {
        this(itemsPerPage, UNKNOWN_ITEMS);
    }

    /**
     * һҳʼΪ޴<code>UNKNOWN_ITEMS</code>ָÿҳ
     * 
     * @param itemsPerPage ÿҳ
     * @param items 
     */
    public Paginator(int itemsPerPage, int items) {
        this.items = items >= 0 ? items : 0;
        this.itemsPerPage = itemsPerPage > 0 ? itemsPerPage : DEFAULT_ITEMS_PER_PAGE;
        this.page = calcPage(0);
    }

    /**
     * ȡҳ
     * 
     * @return ҳ
     */
    public int getPages() {
        return (int) Math.ceil((double) items / itemsPerPage);
    }

    /**
     * ȡõǰҳ
     * 
     * @return ǰҳ
     */
    public int getPage() {
        return page;
    }

    /**
     * òȡõǰҳʵʵĵǰҳֵȷȷķΧڡ
     * 
     * @param page ǰҳ
     * @return úĵǰҳ
     */
    public int setPage(int page) {
        return this.page = calcPage(page);
    }

    /**
     * ȡ
     * 
     * @return 
     */
    public int getItems() {
        return items;
    }

    /**
     * òȡָС0򱻿0ԶǰҳȷǰҳֵȷķΧڡ
     * 
     * @param items 
     * @return Ժ
     */
    public int setItems(int items) {
        this.items = items >= 0 ? items : 0;
        setPage(page);
        return this.items;
    }

    /**
     * ȡÿҳ
     * 
     * @return ÿҳ
     */
    public int getItemsPerPage() {
        return itemsPerPage;
    }

    /**
     * òȡÿҳָÿҳСڵ0ʹĬֵ<code>DEFAULT_ITEMS_PER_PAGE</code>
     * ǰҳʹ֮ڸıÿҳǰʾͬ
     * 
     * @param itemsPerPage ÿҳ
     * @return úÿҳ
     */
    public int setItemsPerPage(int itemsPerPage) {
        int tmp = this.itemsPerPage;

        this.itemsPerPage = itemsPerPage > 0 ? itemsPerPage : DEFAULT_ITEMS_PER_PAGE;

        if (page > 0) {
            setPage((int) ((double) (page - 1) * tmp / this.itemsPerPage) + 1);
        }

        return this.itemsPerPage;
    }

    /**
     * ȡõǰҳһȫеƫ (0-based)
     * 
     * @return ƫ
     */
    public int getOffset() {
        return page > 0 ? itemsPerPage * (page - 1) : 0;
    }

    /**
     * ȡõǰҳĳȣǰҳʵ൱ <code>endIndex() - beginIndex() + 1</code>
     * 
     * @return ǰҳĳ
     */
    public int getLength() {
        if (page > 0) {
            return Math.min(itemsPerPage * page, items) - itemsPerPage * (page - 1);
        } else {
            return 0;
        }
    }

    /**
     * ȡõǰҳʾʼ (1-based)
     * 
     * @return ʼ
     */
    public int getBeginIndex() {
        if (page > 0) {
            return itemsPerPage * (page - 1) + 1;
        } else {
            return 0;
        }
    }

    /**
     * ȡõǰҳʾĩ (1-based)
     * 
     * @return ĩ
     */
    public int getEndIndex() {
        if (page > 0) {
            return Math.min(itemsPerPage * page, items);
        } else {
            return 0;
        }
    }

    /**
     * õǰҳʹ֮ʾָoffset(0-based)
     * 
     * @param itemOffset Ҫʾƫ(0-based)
     * @return ָڵҳ
     */
    public int setItem(int itemOffset) {
        return setPage(itemOffset / itemsPerPage + 1);
    }

    /**
     * ȡҳҳ롣
     * 
     * @return ҳҳ
     */
    public int getFirstPage() {
        return calcPage(1);
    }

    /**
     * ȡĩҳҳ롣
     * 
     * @return ĩҳҳ
     */
    public int getLastPage() {
        return calcPage(getPages());
    }

    /**
     * ȡǰһҳҳ롣
     * 
     * @return ǰһҳҳ
     */
    public int getPreviousPage() {
        return calcPage(page - 1);
    }

    /**
     * ȡǰnҳҳ
     * 
     * @param n ǰnҳ
     * @return ǰnҳҳ
     */
    public int getPreviousPage(int n) {
        return calcPage(page - n);
    }

    /**
     * ȡúһҳҳ롣
     * 
     * @return һҳҳ
     */
    public int getNextPage() {
        return calcPage(page + 1);
    }

    /**
     * ȡúnҳҳ롣
     * 
     * @param n n
     * @return nҳҳ
     */
    public int getNextPage(int n) {
        return calcPage(page + n);
    }

    /**
     * жָҳǷ񱻽ֹҲ˵ָҳ볬˷Χڵǰҳ롣
     * 
     * @param page ҳ
     * @return boolean ǷΪֹҳ
     */
    public boolean isDisabledPage(int page) {
        return page < 1 || page > getPages() || page == this.page;
    }

    /**
     * ȡĬϴС(<code>DEFAULT_SLIDER_SIZE</code>)ҳ뻬ڣǰҳܵطڻڵм䲿λμ
     * {@link #getSlider(int n)}
     * 
     * @return ҳ
     */
    public int[] getSlider() {
        return getSlider(DEFAULT_SLIDER_SIZE);
    }

    /**
     * ȡָСҳ뻬ڣǰҳܵطڻڵм䲿λ: ܹ13ҳǰҳǵ5ҳȡһСΪ5Ļڣ
     * 3456, 7⼸ҳ룬5ҳм䡣ǰҳ12򷵻ҳΪ 910111213
     * 
     * @param width ڴС
     * @return ҳ飬ָڴСС1ҳΪ0򷵻ؿ顣
     */
    public int[] getSlider(int width) {
        int pages = getPages();

        if (pages < 1 || width < 1) {
            return new int[0];
        } else {
            if (width > pages) {
                width = pages;
            }

            int[] slider = new int[width];
            int first = page - (width - 1) / 2;

            if (first < 1) {
                first = 1;
            }

            if (first + width - 1 > pages) {
                first = pages - width + 1;
            }

            for (int i = 0; i < width; i++) {
                slider[i] = first + i;
            }

            return slider;
        }
    }

    /**
     * ҳı䵱ǰҳ
     * 
     * @param page ҳ
     * @return ȷҳ(֤߽)
     */
    protected int calcPage(int page) {
        int pages = getPages();

        if (pages > 0) {
            return page < 1 ? 1 : page > pages ? pages : page;
        }

        return 0;
    }

    /**
     * 
     * 
     * @return 
     */
    @Override
    public Object clone() {
        try {
            return super.clone();
        } catch (java.lang.CloneNotSupportedException e) {
            return null; // ܷ
        }
    }

    /**
     * תַʾ
     * 
     * @return ַʾ
     */
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("Paginator: page ");

        if (getPages() < 1) {
            sb.append(getPage());
        } else {
            int[] slider = getSlider();

            for (int i = 0; i < slider.length; i++) {
                if (isDisabledPage(slider[i])) {
                    sb.append('[').append(slider[i]).append(']');
                } else {
                    sb.append(slider[i]);
                }

                if (i < slider.length - 1) {
                    sb.append('\t');
                }
            }
        }

        sb.append(" of ").append(getPages()).append(",\n");
        sb.append("    Showing items ").append(getBeginIndex()).append(" to ").append(getEndIndex()).append(" (total ")
                .append(getItems()).append(" items), ");
        sb.append("offset=").append(getOffset()).append(", length=").append(getLength());

        return sb.toString();
    }
}
