/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.util.io;

import java.io.IOException;
import java.io.OutputStream;

/**
 * ؽԴд뵽ָ档
 * <p>
 * <code>OutputEngine</code>ʲôã˵ <code>GZIPInputStream</code>Ƕѹнѹ
 * </p>
 * 
 * <pre>
 * read ԭʼ &lt;- decompress &lt;- compressed data stream
 * </pre>
 * <p>
 * <code>GZIPOutputStream</code>Ƕѹ
 * </p>
 * 
 * <pre>
 * write ԭʼ -&gt; compress -&gt; compressed data stream
 * </pre>
 * <p>
 * JDKвһ
 * </p>
 * 
 * <pre>
 * read compressed data &lt;- compress &lt;- ԭʼ
 * </pre>
 * <p>
 * OutputEngineͿʵ
 * </p>
 * <p>
 * ֲIBM developer works£
 * </p>
 * <ul>
 * <li><a
 * href="http://www.ibm.com/developerworks/cn/java/j-io1/index.shtml">ת 1
 * ֣жȡ</a>
 * <li><a
 * href="http://www.ibm.com/developerworks/cn/java/j-io2/index.shtml">ת 2
 * ֣Ż Java ڲ I/O</a>
 * </ul>
 * 
 * @author Michael Zhou
 */
public interface OutputEngine {
    /** Ĭϵ, ֱӷָ. */
    OutputStreamFactory DEFAULT_OUTPUT_STREAM_FACTORY = new OutputStreamFactory() {
        public OutputStream getOutputStream(OutputStream out) {
            return out;
        }
    };

    /**
     * ʼ, ͨ<code>OutputEngine</code>ʵֻὫһ
     * <code>FilterOutputStream</code>ӵָ.
     * 
     * @param out ָ
     * @throws IOException 쳣
     */
    void open(OutputStream out) throws IOException;

    /**
     * ִһ. ˲<code>OutputEngine</code>лᱻִж,
     * ÿζд뵽ʼʱָ.
     * 
     * @throws IOException 쳣
     */
    void execute() throws IOException;

    /**
     * ɨβ. еԺ, ˷.
     * 
     * @throws IOException 쳣
     */
    void close() throws IOException;

    /**
     * Ĺ.
     */
    interface OutputStreamFactory {
        /**
         * , ͨһ<code>FilterOutputStream</code>ӵָ.
         * 
         * @param out ָ
         * @return 
         * @throws IOException 쳣
         */
        OutputStream getOutputStream(OutputStream out) throws IOException;
    }
}
