/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.citrus.webx;

import org.springframework.web.context.WebApplicationContext;

import com.alibaba.citrus.webx.config.WebxConfiguration;

/**
 * һwebx componentϢ
 * 
 * @author Michael Zhou
 */
public interface WebxComponents extends Iterable<WebxComponent> {
    /**
     * ȡcomponentsơ
     */
    String[] getComponentNames();

    /**
     * ȡָƵcomponent
     */
    WebxComponent getComponent(String componentName);

    /**
     * ȡĬϵcomponentδã򷵻<code>null</code>
     */
    WebxComponent getDefaultComponent();

    /**
     * ƥcomponent
     */
    WebxComponent findMatchedComponent(String path);

    /**
     * ȡcontroller
     */
    WebxRootController getWebxRootController();

    /**
     * ȡwebx configurationá
     */
    WebxConfiguration getParentWebxConfiguration();

    /**
     * ȡcomponentĸapplication contextûУ򷵻<code>null</code>
     */
    WebApplicationContext getParentApplicationContext();
}
